import java.awt.*;
public class posgraph extends Canvas {
    Image dots,sketch;
    Graphics dotsg,sketchg;
    double xscale, yscale,maxx,maxy;
    static int NUMSTEPS = 1000;
	static int NUMDIVIS = 10;

	public boolean isReady() {
		return(!((dots==null)|(sketchg==null)));
	}

	private void setupImages(){
  		this.setBackground(Color.white);
            sketch = this.createImage(this.getBounds().width, this.getBounds().height);
            sketchg = sketch.getGraphics();
            sketchg.translate(this.getBounds().width/32, this.getBounds().height/2);
		  dots=this.createImage(this.getBounds().width,this.getBounds().height);
		  dotsg=dots.getGraphics();
		  dotsg.translate(this.getBounds().width/32, this.getBounds().height/2);
		  dotsg.drawLine(0,-this.getBounds().height/2,0,this.getBounds().height/2);
		  dotsg.drawLine(0,0,this.getBounds().width,0);
	}
    
    public void clear() {
	if(sketchg!=null)
		setupImages();
    }
    
    public void paint(Graphics g) {
        if (sketch == null) {
		setupImages();
        }
        g.drawImage(sketch, 0, 0, null);
    }
    
    public void update(Graphics g) {
        paint(g);
    }
    
    public void setScale(double maxX, double maxY) {
		if(dotsg==null)
			return;
		maxx=maxX;
		maxy=maxY;
		xscale=this.getBounds().width/(1.05*maxX);
		yscale=this.getBounds().height/(2.10*maxY);
		for (int i=1;i<NUMDIVIS;i++) {
			dotsg.drawLine((int)(xscale*i*maxx/NUMDIVIS),
							-5,
							(int)(xscale*i*maxx/NUMDIVIS),
							5);
			dotsg.drawString((int)(i*maxx/NUMDIVIS)+"dy",(int)(xscale*i*maxx/NUMDIVIS-20),31*this.getBounds().height/64);
		}
    }
    
    public void drawPlot(double a, double p, double phi, Color c) {
        if (sketchg==null)
            return;
		sketchg.setColor(c);
		for (int i=0;i<NUMSTEPS;i++)
			sketchg.drawLine(
				(int)(xscale*i*maxx/NUMSTEPS),
				(int)(yscale*a*Math.sin(2*Math.PI*i*maxx/(NUMSTEPS*p)+phi)),
				(int)(xscale*(i+1)*maxx/NUMSTEPS),
				(int)(yscale*a*Math.sin(2*Math.PI*(i+1)*maxx/(NUMSTEPS*p)+phi)));
    }

	public void resetPlot() {
	    if (sketchg==null)
	        return;
		sketchg.drawImage(dots,(int)(-this.getBounds().width/32),(int)(-this.getBounds().height/2),null);
	}
	public void drawDot(double x, double y) {
	    if (dotsg==null)
	        return;
		dotsg.drawOval((int)(xscale*x-2),(int)(yscale*y-2),4,4);
	}
}